/*
 * Go2ProfileIsectZ.c
 * 
 * Gocator system communication library
 * Copyright (C) 2013 by LMI Technologies Inc.
 * 
 * Licensed under The MIT License.
 * Redistributions of files must retain the above copyright notice.
 */

#include <z/Go2Measurements/zGo2ProfileIsectZ.h>
#include <z/zGo2ProfileTypes.h>
#include <z/zGo2System.h>
#include <string.h>

/*
 * Go2ProfileIsectZ Class 
 */

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_Construct(Go2ProfileIsectZ* measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfileIsectZ output = zNIL; 
    Go2Status status = GO2_OK; 

    zCHECK(zCalloc(&output, 1, sizeof(Go2ProfileIsectZClass))); 

    if (!zSUCCESS(status = Go2ProfileIsectZ_Init(output, id, system)))
    {
        zCHECK(Go2Object_Destroy(output)); 
        return status; 
    }
    
    *measurement = output; 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_Init(Go2ProfileIsectZ measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfileIsectZClass* obj = zHANDLE_POINTER(measurement);
    z32u i; 

    zCHECK(Go2Measurement_Init(measurement, GO2_TYPE_PROFILE_ISECT_Z, id, system)); 

    obj->Release = Go2ProfileIsectZ_VRelease; 
    obj->Read = Go2ProfileIsectZ_VRead; 
    obj->Write = Go2ProfileIsectZ_VWrite; 

    for (i = 0; i < zCOUNT(obj->lines); ++i)
    {
        zCHECK(Go2ProfileLine_Construct(&obj->lines[i], system));       
    }

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_VRelease(Go2ProfileIsectZ measurement)
{
    Go2ProfileIsectZClass* obj = zHANDLE_POINTER(measurement);
    z32u i; 

    for (i = 0; i < zCOUNT(obj->lines); ++i)
    {
        zCHECK(Go2Object_Destroy(obj->lines[i])); 
    }

    zCHECK(Go2Measurement_VRelease(measurement));  
        
    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_VRead(Go2ProfileIsectZ measurement, zXml xml, zXmlItem item)
{
    Go2ProfileIsectZClass* obj = zHANDLE_POINTER(measurement); 
    zChar* text = zNULL;
    z32u textCapacity = GO2_MEASUREMENT_SOURCE_TEXT_CAPACITY; 

    zXmlItem lineItem = zNIL; 
    z32u i; 

    zCHECK(Go2Measurement_VRead(measurement, xml, item)); 

    zCHECK(zCalloc(&text, textCapacity, sizeof(zChar)));
    zCHECK(zXml_ChildText(xml, item, "SourceOptions", text, textCapacity)); 
    zCHECK(Go2OptionList_ParseList(text, obj->sourceOptions));  

    zCHECK(zXml_Child32u(xml, item, "Source", &obj->source)); 
    

    lineItem = zXml_Child(xml, item, "Line"); 

    for (i = 0; i < zCOUNT(obj->lines); ++i)
    {
        zCHECK(!zIS_NIL(lineItem)); 
        zCHECK(Go2ProfileLine_Read(obj->lines[i], xml, lineItem)); 

        lineItem = zXml_NextSibling(xml, lineItem); 
    }

    zCHECK(zFree(text));

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_VWrite(Go2ProfileIsectZ measurement, zXml xml, zXmlItem item)
{
    Go2ProfileIsectZClass* obj = zHANDLE_POINTER(measurement); 
    zXmlItem lineItem = zNIL; 
    z32u i; 

    zCHECK(Go2Measurement_VWrite(measurement, xml, item)); 

    zCHECK(zXml_SetChild32u(xml, item, "Source", obj->source)); 

    for (i = 0; i < zCOUNT(obj->lines); ++i)
    {
        zCHECK(zXml_AddItem(xml, item, "Line", &lineItem)); 
        zCHECK(Go2ProfileLine_Write(obj->lines[i], xml, lineItem)); 
    }

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_SetId(Go2ProfileIsectZ measurement, Go2UInt32 id)
{
    return Go2Measurement_SetId(measurement, id);     
}

GO2_EXPORT(Go2UInt32) Go2ProfileIsectZ_Id(Go2ProfileIsectZ measurement)
{
    return Go2Measurement_Id(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_SetName(Go2ProfileIsectZ measurement, const Go2Char* name)
{
    return Go2Measurement_SetName(measurement, name);     
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_Name(Go2ProfileIsectZ measurement, Go2Char* name, Go2UInt32 capacity)
{
    return Go2Measurement_Name(measurement, name, capacity);     
}

GO2_EXPORT(Go2UInt32) Go2ProfileIsectZ_SourceOptionCount(Go2ProfileIsectZ measurement)
{
    return Go2Measurement_SourceOptionCount(measurement);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfileIsectZ_SourceOptionAt(Go2ProfileIsectZ measurement, Go2UInt32 index)
{
    return Go2Measurement_SourceOptionAt(measurement, index);     
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_SetSource(Go2ProfileIsectZ measurement, Go2ProfileSource source)
{
    return Go2Measurement_SetSource(measurement, source);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfileIsectZ_Source(Go2ProfileIsectZ measurement)
{
    return Go2Measurement_Source(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_SetDecisionMin(Go2ProfileIsectZ measurement, Go2Double min)
{
    return Go2Measurement_SetDecisionMin(measurement, min);     
}

GO2_EXPORT(Go2Double) Go2ProfileIsectZ_DecisionMin(Go2ProfileIsectZ measurement)
{
    return Go2Measurement_DecisionMin(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_SetDecisionMax(Go2ProfileIsectZ measurement, Go2Double max)
{
    return Go2Measurement_SetDecisionMax(measurement, max);     
}

GO2_EXPORT(Go2Double) Go2ProfileIsectZ_DecisionMax(Go2ProfileIsectZ measurement)
{
    return Go2Measurement_DecisionMax(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_EnableHold(Go2ProfileIsectZ measurement, Go2Bool enable)
{
    return Go2Measurement_EnableHold(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfileIsectZ_HoldEnabled(Go2ProfileIsectZ measurement)
{
    return Go2Measurement_HoldEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_EnableSmoothing(Go2ProfileIsectZ measurement, Go2Bool enable)
{
    return Go2Measurement_EnableSmoothing(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfileIsectZ_SmoothingEnabled(Go2ProfileIsectZ measurement)
{
    return Go2Measurement_SmoothingEnabled(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileIsectZ_SmoothingWindowMin(Go2ProfileIsectZ measurement)
{
    return Go2Measurement_SmoothingWindowMin(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileIsectZ_SmoothingWindowMax(Go2ProfileIsectZ measurement)
{
    return Go2Measurement_SmoothingWindowMax(measurement);  
} 

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_SetSmoothingWindow(Go2ProfileIsectZ measurement, Go2UInt32 window)
{
    return Go2Measurement_SetSmoothingWindow(measurement, window);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileIsectZ_SmoothingWindow(Go2ProfileIsectZ measurement)
{
    return Go2Measurement_SmoothingWindow(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileIsectZ_LineCount(Go2ProfileIsectZ measurement)
{
    Go2ProfileIsectZClass* obj = zHANDLE_POINTER(measurement); 
    return zCOUNT(obj->lines); 
}

GO2_EXPORT(Go2ProfileLine) Go2ProfileIsectZ_LineAt(Go2ProfileIsectZ measurement, Go2UInt32 index)
{
    Go2ProfileIsectZClass* obj = zHANDLE_POINTER(measurement); 
    return obj->lines[index];  
}



GO2_EXPORT(Go2Status) Go2ProfileIsectZ_SetScale(Go2ProfileIsectZ measurement, Go2Double scale){
    return Go2Measurement_SetScale(measurement, scale);
}

GO2_EXPORT(Go2Double) Go2ProfileIsectZ_Scale(Go2ProfileIsectZ measurement){
    return Go2Measurement_Scale(measurement);
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_SetOffset(Go2ProfileIsectZ measurement, Go2Double offset){
    return Go2Measurement_SetOffset(measurement, offset);
}

GO2_EXPORT(Go2Double) Go2ProfileIsectZ_Offset(Go2ProfileIsectZ measurement){
    return Go2Measurement_Offset(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfileIsectZ_LinkOptionCount(Go2ProfileIsectZ measurement)
{
    return Go2Measurement_LinkOptionCount(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfileIsectZ_LinkOptionAt(Go2ProfileIsectZ measurement, Go2UInt32 index)
{
    return Go2Measurement_LinkOptionAt(measurement, index);
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_EnableLink(Go2ProfileIsectZ measurement, Go2Bool enable)  
{
    return Go2Measurement_EnableLink(measurement, enable);  
}

GO2_EXPORT(Go2Bool) Go2ProfileIsectZ_LinkEnabled(Go2ProfileIsectZ measurement)  
{
    return Go2Measurement_LinkEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfileIsectZ_SetLink(Go2ProfileIsectZ measurement, Go2UInt32 link) 
{
    return Go2Measurement_SetLink(measurement, link); 
}

GO2_EXPORT(Go2UInt32) Go2ProfileIsectZ_Link(Go2ProfileIsectZ measurement) 
{
    return Go2Measurement_Link(measurement); 
}
